import { useAppSelector } from '@/redux/hooks/useAppSelector';
import {
  numberOfMirnasSelector,
  loadingMirnasStatusSelector,
} from '@/redux/mirnas/mirnas.selectors';
import { AccordionItem, AccordionItemHeading, AccordionItemButton } from '@/shared/Accordion';

export const MirnaAccordion = (): JSX.Element => {
  const mirnaNumber = useAppSelector(numberOfMirnasSelector);
  const mirnaState = useAppSelector(loadingMirnasStatusSelector);

  return (
    <AccordionItem>
      <AccordionItemHeading>
        <AccordionItemButton variant="non-expandable">
          MiRNA
          {mirnaState === 'pending' && ' (Loading...)'}
          {mirnaState === 'succeeded' && ` (${mirnaNumber})`}
        </AccordionItemButton>
      </AccordionItemHeading>
    </AccordionItem>
  );
};
