import { BioEntityContent, Chemical, Drug, Mirna } from '@/types/models';
import { useAppDispatch } from '@/redux/hooks/useAppDispatch';
import { displayEntityDetails } from '@/redux/drawer/drawer.slice';
import { PinItem, PinType } from './PinsList.types';
import { PinsListItem } from './PinsListItem';

interface PinsListProps {
  pinsList: PinItem[];
  type: PinType;
}

export const PinsList = ({ pinsList, type }: PinsListProps): JSX.Element => {
  const dispatch = useAppDispatch();

  const onPinClick = (data: BioEntityContent | Drug | Chemical | Mirna): void => {
    dispatch(displayEntityDetails(data));
  };

  return (
    <ul className="px-6 py-2">
      {pinsList.map(pin => (
        <PinsListItem
          key={pin.id}
          name={pin.name}
          type={type}
          onClick={(): void => onPinClick(pin.data)}
        />
      ))}
    </ul>
  );
};
