import { DrawerState } from '@/redux/drawer/drawer.types';
import { createSlice } from '@reduxjs/toolkit';
import {
  closeDrawerReducer,
  displayDrugsListReducer,
  displayEntityDetailsReducer,
  displayGroupedSearchResultsReducer,
  openDrawerReducer,
  openSearchDrawerReducer,
} from './drawer.reducers';

const initialState: DrawerState = {
  isOpen: false,
  drawerName: 'none',
  searchDrawerState: {
    currentStep: 0,
    stepType: 'none',
    selectedValue: undefined,
  },
};

const drawerSlice = createSlice({
  name: 'drawer',
  initialState,
  reducers: {
    openDrawer: openDrawerReducer,
    openSearchDrawer: openSearchDrawerReducer,
    closeDrawer: closeDrawerReducer,
    displayDrugsList: displayDrugsListReducer,
    displayGroupedSearchResults: displayGroupedSearchResultsReducer,
    displayEntityDetails: displayEntityDetailsReducer,
  },
});

export const {
  openDrawer,
  openSearchDrawer,
  closeDrawer,
  displayDrugsList,
  displayGroupedSearchResults,
  displayEntityDetails,
} = drawerSlice.actions;

export default drawerSlice.reducer;
